

\section{Related Work}\label{sec:discussion}


Our {\modediagram} can be broadly considered as a variant of Statecharts~\cite{statechart}, where a mode in  {\modediagram} is similar to a state in the Statecharts. However, we note the following distinctions: (1) In Statecharts, when a transition guard holds, the system immediately switches to the target state. But in {\modediagram}, mode switches are only allowed to be triggered at the end of a period.\hide{, since it is for the description of the periodic-driven system.} (2) In Statecharts, a transition guard is usually a boolean expression on the current(source) state; while in {\modediagram},  transition guards may involve past states via predicates like $\mathsf{during}$ and $\mathsf{after}$. (3) In Statecharts, all observations on the system are the states; while   {\modediagram} also concerns about the computation aspect of the system by means of the flow graphs provided in the leaf modes.

Timed Automata are a modeling tool for the description and  verification of real-time systems~\cite{AlurTTA,UppaalBehrmannDLPY11}. It provides the $clock$ variable to support the time explicitly. Timed Automata only focus on the linear computation for time since it has nice time zone semantics supporting the timed verification. Hybrid Automata~\cite{HybridAlurCHH92} extend the traditional automata to deal with complex computation like the difference and differentiation while it is not a systematic modeling tool which supports the rich modeling mechanisms like the hierarchy, types etc.

Giese et al.~\cite{rtsc} have proposed a semantics of real-time variant of Statecharts by introducing the Hierarchical Timed Automata. In another work~\cite{RealTimeUMLGiese} they have presented a compositional verification approach to the real time UML designs. A. K. Mok et al. have developed a kind of herarchical real-time chart named ``Modechart''~\cite{ModechartMok}. Compared with Giese et al.~\cite{rtsc}, parallel modes are supported in Modechart.

Stateflow is the Statechart-like language used in the commercial software Matlab/Simulink~\cite{stateflow}. The Stateflow language enriches  Statecharts to allow it to support  flow-based and state-based computations together for specifying  discrete event systems. Our {\modediagram}  focuses more on  periodic control systems, which can be regarded as a specific type of  discrete event systems, and it provides the first class element \textit{period} to facilitate the precise modeling of periodic-driven systems. The transitions in Stateflow can be attached with a flowchart to describe  complicated computation,  the {\modediagram} specifies the flow graph for the computation in its leaf modes. While Stateflow focuses only on the modeling aspect of the systems,  the {\modediagram} integrates modeling and reasoning by providing a property specification language with a verification algorithm.

Some researchers  introduce \textit{operational modes}~\cite{OhMultiMode,SchmitzAE05Mode} during the modeling in hardware/software co-synthesis. The operational mode is essentially a state in the automaton, but it can be attached a flowchart for the description of the computation. It does not support the nested mode and period explicitly. However, it is actually an informal modeling notation because it allows to specify the system behaviors in natural language. Our {\modediagram} is a lightweight formal notation for the modeling with its precise operational semantics.

Giotto is also a periodic-driven modeling language proposed by Henzinger et al.~\cite{giotto}. The main difference between Giotto and {\modediagram} is the computation mechanism provided. The tasks in a mode can be performed in parallel in Giotto while  the details of the tasks are omitted and are moved to the implementation stage. The {\modediagram} supports the detailed description of the computation in their leaf modes since the design of it is targeted for  control systems which may involve rich algorithms. The {\modediagram} does not support the parallel computation explicitly at present since it could bring the nondeterminism at the design level. The emphasis of the Giotto is more for the modeling and synthesis of  parallel tasks while the {\modediagram} is for the modeling and verification based on the proposed specification language.

Runtime Verification is a verification approach based on extracting information by executing the system and using the information to detect whether the observed behaviors violating the expected properties~\cite{RVHavelund,RVStolz}. The verification approach we apply in this paper is also a kind of runtime verification. But our methodology is the off-line analysis, while ~\cite{RVStolz} applies an on-line monitoring approach using Aspect-J. The reason to propose off-line analysis is that the cost to decide if an ITL formula is satisfiable on a given trace is expensive, so information extraction and analysis are separated to two phases in our approach.


\section{Conclusion}\label{sec:conclusion}

In this paper, we propose the \underline{M}ode \underline{D}iagram \underline{M}odeling framework ({\modediagram}), a domain-specific formal visual modeling language  for periodic control systems. To support formal reasoning, {\modediagram} is equipped with a property specification language based on interval temporal logic and a statistical model checking algorithm. The property specification language allows engineers to precisely capture various properties they desire, while the verification algorithm allows them to reason about {\modediagram} models with respect to those properties. The viability and effectiveness of the proposed {\modediagram} framework have been demonstrated by a number of real-life case studies, where defects of spacecraft control systems have been uncovered in the early design stage.










